<template>
    <tr>
        <td><input type="checkbox" :checked="checked" @input="$emit('checkboxclicked', id)" :disabled="disabled" class="form-check-input" /></td>
        <td>{{ entity.data._name }}</td>
        <td v-for="column in extraColumns">{{ entity.data[column.key] ?? '' }}</td>
        <td>{{ stateMsg }}</td>
        <td>
            <button @click="$emit('main-btn-click', id)" class="btn btn-primary" :disabled="disabled" v-if="showMainActionBtn">{{mainActionBtnLabel}}</button>
            <button @click="$emit('delete-btn-click', id)" class="btn btn-danger ms-2" :disabled="disabled" v-if="showDeleteBtn">Elimina</button>
        </td>
    </tr>
</template>

<script>
export default {
    name: "SyncTableTr",
    props: ['entity', 'entityType', 'checked', 'id', 'extraColumns', 'showDeleteBtn', 'showMainActionBtn', 'mainActionBtnLabel', 'initialStateLabel'],
    computed: {
        stateMsg: function () {
            if (this.entity.error !== null) {
                return "Errore: " + this.entity.error;
            }

            if (this.entityType === "students" && this.entity.data.internalGroupId === null) {
                return "Disabilitato per classe non importata";
            }

            if (this.entityType === "groups" && this.entity.data.internalSectorId === null) {
                return "Disabilitato per settore non importato";
            }

            switch (this.entity.state) {
                case 1:
                    return "In Coda";

                case 2:
                    return "Elaborazione";

                case 3:
                    return "Completato";

                default:
                    return this.initialStateLabel;
            }
        },
        disabled: function () {
            if (this.entity.state > 0) {
                return true;
            }

            if (this.entityType === "students" && typeof this.entity.data === "object" && this.entity.data.internalGroupId === null) {
                return true;
            }

            if (this.entityType === "groups" && typeof this.entity.data === "object" && this.entity.data.internalSectorId === null) {
                return true;
            }

            return false;
        }
    }
}
</script>

<style lang="scss" scoped>

</style>